---
title: XRInputSourceArray.forEach()
slug: Web/API/XRInputSourceArray/forEach
tags:
  - API
  - AR
  - Input Sources
  - Inputs
  - Method
  - Mixed
  - Reality
  - Reference
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRInputSourceArray
  - augmented
  - forEach
---
<p>{{APIRef("WebXR Device API")}}{{SecureContext_header}}</p>

<p>The {{domxref("XRInputSourceArray")}} method <code><strong>forEach()</strong></code> executes the specified callback once for each input source in the array, starting at index 0 and progressing until the end of the list.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>xrInputSourceArray</em>.forEach(<em>callback</em>, <em>thisArg</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>callback</code></dt>
 <dd>
 <p>A function to execute once for each entry in the array <code>xrInputSourceArray</code>. The callback accepts up to three parameters:</p>

 <dl>
  <dt><code>currentValue</code></dt>
  <dd>A {{domxref("XRInputSource")}} object which is the value of the item from within the <code>xrInputSourceArray</code> which is currently being processed.</dd>
  <dt><code>currentIndex</code> {{optional_inline}}</dt>
  <dd>An integer value providing the index into the array at which the element given by <code>currentValue</code> is located. If you don't need to know the index number, you can omit this.</dd>
  <dt><code>sourceList</code> {{optional_inline}}</dt>
  <dd>The {{domxref("XRInputSourceArray")}} object which is being processed. If you don't need this information, you may omit this.</dd>
 </dl>
 </dd>
 <dt><code>thisArg</code> {{optional_inline}}</dt>
 <dd>The value to be used for <code><a href="/en-US/docs/Web/JavaScript/Reference/Operators/this">this</a></code> while executing the callback. Note that if you use <a href="/en-US/docs/Web/JavaScript/Reference/Functions/Arrow_functions">arrow function notation</a> (<code>=&gt;</code>) to provide the callback, you can omit <code>thisArg</code>, since all arrow functions lexically bind <code>this</code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>Undefined.</p>

<h2 id="Examples">Examples</h2>

<p>This example snippet gets the list of inputs for a session and tries to handle each type of input device it supports using.</p>

<pre class="brush: js">let inputSources = xrSession.inputSources;

inputSources.forEach((input) =&gt; {
  if (input.gamepad) {
    checkGamepad(input.gamepad);
  } else {
    if (input.targetRayMode === "tracked-pointer" &amp;&amp;
        input.handedness === player.handedness) {
      /* Handle main hand controller */
      handleMainHandInput(input);
    } else {
      /* Handle other inputs */
    }
  }
});
</pre>

<p>For each input in the llist, the callback dispatches gamepad inputs to a <code>checkGamepad()</code> with the input's {{domxref("Gamepad")}} object, taken from its {{domxref("XRInputSource.gamepad", "gamepad")}} property, as an input</p>

<p>For other devices, we look for <code>tracked-pointer</code> devices in the player's main hand, dispatching those to a <code>handleMainHandInput()</code> method.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebXR','#xrinputsourcearray','XRInputSourceArray')}}<sup><a href="#spec-iterables">1</a></sup></td>
   <td>{{Spec2('WebXR')}}</td>
   <td><code>XRInputSourceArray</code> interface</td>
  </tr>
 </tbody>
</table>

<p><a id="spec-iterables">[1]</a> See {{SectionOnPage("/en-US/docs/MDN/Contribute/Howto/Write_an_API_reference/Information_contained_in_a_WebIDL_file", "Iterator-like methods")}} for information on how an <code>iterable</code> declaration in an interface definition causes <code>entries()</code>, <code>forEach()</code>, <code>keys()</code>, and <code>values()</code> methods to be exposed from objects that implement the interface.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRInputSourceArray.forEach")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs">Inputs and input sources</a></li>
 <li>The <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array">Array</a></code> method <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/forEach">forEach(</a>)</code></li>
 <li>{{domxref("XRInputSource")}}</li>
</ul>
